"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var registerRoutes_exports = {};
__export(registerRoutes_exports, {
  default: () => registerRoutes_default
});
module.exports = __toCommonJS(registerRoutes_exports);
var import_reflect_metadata = require("reflect-metadata");
var import_utils = require("./utils");
const registerRoutes = (app, handlerInfos) => {
  handlerInfos.forEach(({ routePath, handler, httpMethod }) => {
    const routeHandler = (0, import_utils.createRouteHandler)(handler);
    const method = httpMethod.toLowerCase();
    const routeMiddlwares = Reflect.getMetadata("middleware", handler) || [];
    if (routeMiddlwares.length > 0) {
      app[method](routePath, routeMiddlwares, routeHandler);
    } else {
      app[method](routePath, routeHandler);
    }
  });
};
var registerRoutes_default = registerRoutes;
